var createError = require('http-errors');
var express = require('express');
var path = require('path');
var cookieParser = require('cookie-parser');
var favicon = require('serve-favicon');
var logger = require('morgan');
var fs = require("fs")
var uuid = require('uuid');
var CryptoJS = require("crypto-js")
var fileUpload = require('express-fileupload')
var ntr = require("./neutral-functions.js")


var indexRouter = require('./routes/index');
var loginRouter = require('./routes/login');
var signoutRouter = require('./routes/signout');
var getRouter = require('./routes/get');
var setRouter = require('./routes/set');
var uploadRouter = require('./routes/upload');
var userManagerRouter = require('./routes/usermanager');
var linkRouter = require('./routes/link');



var app = express();

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'ejs');

app.use(logger('dev'));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));
app.use(favicon(path.join(__dirname +  '/public/' +  'favicon.ico')))
app.use(fileUpload({
  debug: true,
}));

app.use('/', indexRouter);
app.use('/login', loginRouter);
app.use('/signout', signoutRouter);
app.use('/get', getRouter);
app.use('/set', setRouter)
app.use('/upload', uploadRouter)
app.use('/usermanager', userManagerRouter)
app.use('/link', linkRouter)


// catch 404 and forward to error handler
app.use(function(req, res, next) {
  next(createError(404));
});

// error handler
app.use(function(err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});


ntr.checkUser()


module.exports = app;
